// /////////////////////////////////////////////////////////////////////////
// SystemC code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#ifndef SENSOR_HH
#define SENSOR_HH

#include <stdint.h>
#include <systemc>

class sensor :
    public sc_core::sc_module
{

public:

    sc_core::sc_in< bool > pclk;
    sc_core::sc_in< bool > presetn;
    sc_core::sc_in< uint32_t > paddr;
    sc_core::sc_in< bool > psel;
    sc_core::sc_in< bool > penable;
    sc_core::sc_in< bool > pwrite;
    sc_core::sc_in< uint32_t > pwdata;
    sc_core::sc_out< bool > pready;
    sc_core::sc_out< uint32_t > prdata;
    sc_core::sc_in< bool > sensor_high;
    sc_core::sc_in< bool > sensor_low;
    uint32_t prdata_var_1;


    SC_HAS_PROCESS( sensor );

    sensor( sc_core::sc_module_name name_ );
    ~sensor();


private:

    sensor( const sensor & );
    const sensor& operator= ( const sensor & );


    void process();

};


#endif

